module.exports = {
	env: {
		commonjs: true,
		es6: true,
		node: true,
		jest: true
	},
	extends: 'eslint:recommended',
	parserOptions: {
		ecmaVersion: 2017,
		sourceType: 'module'
	},
	rules: {
		indent: ['error', 'tab', { SwitchCase: 1 } ],
		'linebreak-style': ['error', 'unix'],
		'keyword-spacing': ['error', { before: true, after: true } ],
		'no-unused-vars': ['error', { vars: 'all', args: 'none' } ],
		quotes: ['error', 'single'],
		semi: ['error', 'always'],
		'space-before-blocks': 'error',
		'space-before-function-paren': 'error',
		'prefer-const': ['error'],
		eqeqeq: ['error', 'always'],
		'arrow-spacing': ['error', { before: true, after: true } ],
		'space-infix-ops': ['error'],
		'generator-star-spacing': ['error', { before: true, after: true } ],
		'no-useless-computed-key': 'error',
		'no-useless-constructor': 'error',
		'no-useless-rename': 'error',
		'prefer-spread': 'error',
		'yield-star-spacing': ['error', 'both'],
		'no-var': 'error',
		'prefer-template': 'error',
		'rest-spread-spacing': ['error'],
		'prefer-rest-params': 'error',
		'prefer-arrow-callback': ['error', { allowNamedFunctions: true } ],
		'no-duplicate-imports': 'error',
		'object-curly-spacing': ['error', 'always'],
		'no-unsafe-negation': 'error',
		'dot-location': ['error', 'property'],
		'dot-notation': 'error',
		'no-else-return': 'error',
		'no-extra-label': 'error',
		'no-floating-decimal': 'error',
		'no-multi-spaces': 'error',
		'no-useless-return': 'error',
		'wrap-iife': ['error', 'inside'],
		yoda: ['error', 'never', { exceptRange: true } ],
		'no-undef-init': 'error',
		'array-bracket-spacing': ['error', 'never', { objectsInArrays: true } ],
		'block-spacing': ['error', 'always'],
		'brace-style': ['error', '1tbs', { allowSingleLine: true } ],
		'capitalized-comments': ['error', 'always'],
		'comma-spacing': ['error', { before: false, after: true } ],
		'comma-style': ['error', 'last'],
		'computed-property-spacing': ['error', 'never'],
		'eol-last': ['error', 'always'],
		'func-call-spacing': ['error', 'never'],
		'jsx-quotes': ['error', 'prefer-double'],
		'key-spacing': ['error', { beforeColon: false } ],
		'new-parens': 'error',
		'no-lonely-if': 'error',
		'no-multiple-empty-lines': ['error', { max: 1, maxBOF: 1, maxEOF: 1 } ],
		'no-trailing-spaces': 'error',
		'no-unneeded-ternary': 'error',
		'no-whitespace-before-property': 'error',
		'padded-blocks': ['error', 'never'],
		'quote-props': ['error', 'as-needed'],
		'space-in-parens': ['error', 'never'],
		'space-unary-ops': 'error',
		'spaced-comment': ['error', 'always'],
		'template-tag-spacing': ['error', 'always'],
		'object-shorthand': ['error', 'always'],
		'sort-imports': ['error', {
			ignoreCase: false,
			ignoreMemberSort: false,
			memberSyntaxSortOrder: ['none', 'all', 'multiple', 'single']
		} ]
	}
};
